﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using UnityEngine.UI;

using UnityEngine.SceneManagement;

public class Manager : MonoBehaviour
{
    [System.Serializable]
    public struct MessageText
    {
        public ErroredText[] text;
        public float difficulty;
    }

    [System.Serializable]
    public struct ErroredText
    {
        public string text;
        public string erroredText;

        public bool endOfText;
    }

    public MessageText[] sentMessages;

    public MessageText[] recievedMessages;

    public Sender s;

    int messageIndex = 0;
    int wordIndex = 0;

    int rec_messageIndex = 0;
    int rec_wordIndex = 0;

    public Text senderOriginal;
    public Text recieverOriginal;
    public Text senderSent;

    public string writtenMessage;
    public string Recieved;


    public int sentMessagesNum = 0;
    public int recMessagesNum = 0;

    public bool waitForRecieve = false;

    // Use this for initialization
    void Start()
    {
        senderOriginal.text = sentMessages[0].text[0].text;

        sentMessagesNum += sentMessages[0].text.Length;

        senderSent.text = "";

        recieverOriginal.text = "";
    }

    // Update is called once per frame
    void Update()
    {
        //Input

        if (Input.GetKeyDown(KeyCode.Mouse0))
        {

            RaycastHit hit;
            Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);

            if (Physics.Raycast(ray, out hit))
            {
                Debug.Log(hit.transform.name);

                Transform objectHit = hit.transform;

                GameObject go = objectHit.gameObject;

                Interactable i = go.GetComponent<Interactable>();

                if (i)
                {
                    Debug.Log("Interactable");

                    i.Interact();
                }

                // Do something with the object that was hit by the raycast.
            }

        }


        //

        if (Input.GetKeyDown(KeyCode.E) /*&& !waitForRecieve*/)
        {
            waitForRecieve = true;

            s.startSignal(sentMessages[messageIndex].text[wordIndex].text, sentMessages[messageIndex].difficulty * 10.0f, sentMessages[messageIndex].text[wordIndex].erroredText);

            if (wordIndex < sentMessages[messageIndex].text.Length - 1)
            {
                wordIndex++;
            }
            else
            {
                if (messageIndex < sentMessages.Length - 1)
                {
                    messageIndex++;
                    wordIndex = 0;

                    senderOriginal.text = "";
                    for (int i = 0; i < sentMessages[messageIndex].text.Length; i++)
                    {
                        senderOriginal.text += sentMessages[messageIndex].text[i].text + " ";
                    }
                }
                else
                {
                    Debug.LogWarning("HE Won !!!");

                    SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex + 1);

                }
            }

            //s.startSignal("Hey", diificulty);
        }

    }

    public void recieved(string mes)
    {
        waitForRecieve = false;

        recMessagesNum++;

        Recieved += mes + " ";

        senderSent.text = Recieved;

        if (recMessagesNum == sentMessagesNum)
        {

            Recieved = "";

            sentMessagesNum += sentMessages[messageIndex].text.Length;

            recieverOriginal.text = "";

            if (rec_messageIndex >= recievedMessages.Length)
                return;

            for (int i = 0; i < recievedMessages[rec_messageIndex].text.Length; i++)
            {
                recieverOriginal.text += recievedMessages[rec_messageIndex].text[i].text + " ";
            }

            rec_messageIndex++;
            rec_wordIndex = 0;
        }
    }
}
