﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Signal : MonoBehaviour
{

    public Wire wire;
    public Vector3[] path;

    public Vector3 target;

    public bool testGo;

    int targetIndex;

    public float movingSpeed;

    public string text;
    public string wrongText;

    public GameObject sendingAntenna;

    void Start()
    {

    }

    void Update()
    {
        if (testGo)
        {
            path = wire.getPath();

            //Debug.Log("started moving" + path.Length);

            testGo = false;
        }

        if (path.Length > 0 && targetIndex < path.Length)
        {

            float sqrDist = Vector3.SqrMagnitude(path[targetIndex] - transform.position);

            //Debug.Log(path[targetIndex] + " " + transform.position);

            transform.Translate((path[targetIndex] - transform.position).normalized * movingSpeed * Time.deltaTime);

            if (sqrDist < 0.01f)
                targetIndex++;

        }

    }

    public void setText(string message)
    {
        text = message;
    }

    public void setWire(Wire _wire)
    {
        wire = _wire;
    }

    public void startSignal()
    {
        testGo = true;
    }

    void OnTriggerEnter(Collider other)
    {
        if (other.tag == "Antenna")
        {
            if (other.gameObject == sendingAntenna)
                return;

            Antenna a = other.GetComponent<Antenna>();

            if (a)
            {
                a.SendMessageSignal(text, movingSpeed, wrongText);
            }

            Destroy(gameObject);

        }
    }
}
