﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Signal_EM : MonoBehaviour
{
    public float impedence;

    public float speed;

    public string text;
    public string wrongText;

    public bool exitedAntenna;

    public float maxDist = 10000.0f;

    public bool reflecting = false;

    // Use this for initialization
    void Start()
    {

    }

    // Update is called once per frame
    void Update()
    {
        transform.Translate(Vector3.forward * Time.deltaTime * speed);

        if (transform.position.sqrMagnitude > maxDist)
        {
            Destroy(gameObject);
        }

    }

    void OnTriggerExit(Collider other)
    {
        Debug.Log(other.tag);

        if (other.tag == "Antenna")
        {
            exitedAntenna = true;
        }
        else if (other.tag == "Reflector")
        {
            reflecting = false;
        }
    }

    void OnTriggerEnter(Collider other)
    {
        //Debug.Log(other.name);

        if (exitedAntenna)
        {

            if (other.tag == "Antenna")
            {
                Debug.Log("Recieved");

                Antenna a = other.GetComponent<Antenna>();

                if (a)
                    a.sendWired(text, speed, wrongText);

                Destroy(gameObject);
            }

            else if (other.tag == "Clouds")
            {
                string temp = text;
                text = wrongText;
                wrongText = temp;

                //Debug.Log("Interfered");
            }

            else if (other.tag == "Reflector")
            {
                if (!reflecting)
                {
                    //Debug.Log("Reflection");

                    if (Vector3.Dot(transform.forward, other.transform.forward) < 0)
                    {
                        Vector3 newForward = Vector3.Reflect(transform.forward, other.transform.forward);

                        transform.rotation = Quaternion.LookRotation(newForward);
                        transform.position = other.transform.position + Vector3.up * 2.25f;

                        reflecting = true;
                    }
                    else
                    {
                        Destroy(gameObject);
                    }
                }
            }
            else
            {
                //Debug.Log("Sound here");
                Destroy(gameObject);
            }

        }

    }
}