﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(LineRenderer))]
public class Wire : MonoBehaviour
{
    LineRenderer wireGraphics;

    Vector3[] positions;

    // Use this for initialization
    void Awake()
    {
        wireGraphics = GetComponent<LineRenderer>();

        wireGraphics.numCapVertices = 30;
        wireGraphics.numCornerVertices = 30;


        int chlidrenCount = transform.childCount;

        positions = new Vector3[chlidrenCount];

        int i = 0;
        foreach (Transform child in transform)
        {
            positions[i++] = child.position;
        }


        wireGraphics.positionCount = chlidrenCount;
        wireGraphics.SetPositions(positions);

    }


    public Vector3[] getPath()
    {
        return positions;
    }

    public Vector3 getStart()
    {
        return positions[0];
    }

    public Vector3[] getPathReversed()
    {
        int chlidrenCount = positions.Length;

        Vector3[] reversed = new Vector3[chlidrenCount];

        for (int i = 0; i < chlidrenCount; i++)
        {
            reversed[i] = positions[chlidrenCount - i];
        }

        return reversed;
    }

}
